using System;
using System.Windows.Forms;
using System.Drawing;
using System.Windows.Controls;
using Main;
using chartsinitialization;

namespace Main
{
    public partial class TMainForm : Form
    {
        public TMainForm()
        {
            InitializeComponent();
        }
        
        private string subnode = "Random";       
        public double[] ActualValue = new double[100000];
        private int LastActualSamplePlotted = 0;
        private int LastSampleInActualValueArray;
        private bool infiniteloop = true;

        public void FileExitItemClick(System.Object Sender, System.EventArgs _e1)
        {
            this.Close();
        }

        

        public void FormCreate(System.Object Sender, System.EventArgs _e1)
        {
            LastActualSamplePlotted = 0;
            Chart1.Zoom.ZoomPercent(100);
            Chart1.Aspect.View3D = false;
            Chart1.Walls.View3D = false;           
            Chart1.Panel.Gradient.Visible = false;
            Chart1.Panel.Color = chartconstantunits.ChartBackGroundColor;
            Chart1.Header.Text.Remove(0);
            Chart1.Header.Text = subnode;
            Chart1.Header.Text.Insert(0, "");
            Chart1.Header.AutoSize = true;
            this.Show();
            PlotData();
        }

        public void PlotData()
        {
            int TimeTranspiredSinceStartOfTestInMSec;
            chartconstantunits.GLOBAL_ElapsedTimeInMilliseconds(chartconstantunits.START_TIMER_1);
            while (infiniteloop)
            {                
                TimeTranspiredSinceStartOfTestInMSec = chartconstantunits.GLOBAL_ElapsedTimeInMilliseconds(chartconstantunits.TIMER_1);
                LastSampleInActualValueArray = TimeTranspiredSinceStartOfTestInMSec / 100;
                PlotActualValuesUpToSampleNumber(LastSampleInActualValueArray);              
            }
        }

        public void PlotActualValuesUpToSampleNumber(int SampleNumber)
        {
            double Time;
            int DataPoint;
            string Legend;
            for (DataPoint = LastActualSamplePlotted + 1; DataPoint <= SampleNumber; DataPoint++)
            {
                Time = (double)Decimal.Divide(DataPoint, 10);
                Legend = Time.ToString();
                Random abc = new Random();
                ActualValue[DataPoint] = abc.NextDouble();
                Series1.Add(ActualValue[DataPoint],"",Color.Blue);
                Series1.RefreshSeries();
                Series1.Repaint();
                LastActualSamplePlotted++;
            }
            Chart1.Refresh();
            Application.DoEvents();
        }
    }
}
namespace chartsinitialization
{
    public class chartconstantunits
    {
        public static DateTime GLOBAL_StartTimeForThisPart = new DateTime();
        public static Color ChartBackGroundColor = System.Drawing.SystemColors.ButtonFace;
        public const int START_TIMER_1 = 1;
        public const int START_TIMER_2 = 2;
        public const int START_TIMER_3 = 3;
        public const int START_TIMER_4 = 4;
        public const int TIMER_1 = 5;
        public const int TIMER_2 = 6;
        public const int TIMER_3 = 7;
        public const int TIMER_4 = 8;
        public static int GLOBAL_Timer1StartTime = 0;
        public static int GLOBAL_Timer2StartTime = 0;
        public static int GLOBAL_Timer3StartTime = 0;
        public static int GLOBAL_Timer4StartTime = 0;
       

        public static int GLOBAL_ElapsedTimeInMilliseconds(int command)
        {
            int result;
            result = 0;
            switch (command)
            {
                case START_TIMER_1:

                    GLOBAL_Timer1StartTime = System.Environment.TickCount;
                    break;
                case START_TIMER_2:

                    GLOBAL_Timer2StartTime = System.Environment.TickCount;
                    break;
                case START_TIMER_3:

                    GLOBAL_Timer3StartTime = System.Environment.TickCount;
                    break;
                case START_TIMER_4:

                    GLOBAL_Timer4StartTime = System.Environment.TickCount;
                    break;
                case TIMER_1:

                    result = System.Environment.TickCount - GLOBAL_Timer1StartTime;
                    break;
                case TIMER_2:

                    result = System.Environment.TickCount - GLOBAL_Timer2StartTime;
                    break;
                case TIMER_3:

                    result = System.Environment.TickCount - GLOBAL_Timer3StartTime;
                    break;
                case TIMER_4:

                    result = System.Environment.TickCount - GLOBAL_Timer4StartTime;
                    break;
            }
            return result;
        }
        public static void OneSecondDelay()
        {
            GLOBAL_ElapsedTimeInMilliseconds(START_TIMER_1);
            while (GLOBAL_ElapsedTimeInMilliseconds(TIMER_1) < 1000)
            {
                // wait
            }
        }
    }
}